Index: protocols/yahoo/libyahoo2.c
===================================================================
--- protocols/yahoo/libyahoo2.c	(revision 241f9f6d9135048578ad603485740b73402edd8a)
+++ protocols/yahoo/libyahoo2.c	(revision 18c6d369d777a1d38ef450f868c22de1d0ebba2d)
@@ -1809,5 +1809,4 @@
 	struct yahoo_input_data *yid = had->yid;
 	struct yahoo_data *yd = yid->yd;
-	struct http_request *req;
 	char *login, *passwd, *chal;
 	char *url;
@@ -1823,5 +1822,5 @@
 	                       (int) time(NULL), login, passwd, chal);
 	
-	req = http_dorequest_url(url, yahoo_https_auth_token_finish, had);
+	http_dorequest_url(url, yahoo_https_auth_token_finish, had);
 	
 	g_free(url);
@@ -1870,5 +1869,4 @@
 static void yahoo_https_auth_init(struct yahoo_https_auth_data *had)
 {
-	struct http_request *req;
 	char *url;
 	
@@ -1876,5 +1874,5 @@
 	                      (int) time(NULL), had->token);
 	
-	req = http_dorequest_url(url, yahoo_https_auth_finish, had);
+	http_dorequest_url(url, yahoo_https_auth_finish, had);
 	
 	g_free(url);
@@ -1990,6 +1988,4 @@
 {
 	struct yahoo_data *yd = yid->yd;
-	char *login_id;
-	char *handle;
 	char *url = NULL;
 	int login_status = -1;
@@ -2000,7 +1996,7 @@
 		struct yahoo_pair *pair = l->data;
 		if (pair->key == 0)
-			login_id = pair->value;
+			; /* login_id */
 		else if (pair->key == 1)
-			handle = pair->value;
+			; /* handle */
 		else if (pair->key == 20)
 			url = pair->value;
@@ -2089,7 +2085,5 @@
 	char *msg = NULL;
 	char *name = NULL;
-	long tm = 0L;
 	int state = YAHOO_STATUS_AVAILABLE;
-	int online = 0;
 	int away = 0;
 	int idle = 0;
@@ -2111,7 +2105,7 @@
 			state = strtol(pair->value, NULL, 10);
 		else if (pair->key == 15)
-			tm = strtol(pair->value, NULL, 10);
+			; /* tm */
 		else if (pair->key == 13)
-			online = strtol(pair->value, NULL, 10);
+			; /* online */
 		else if (pair->key == 47)
 			away = strtol(pair->value, NULL, 10);
@@ -2140,5 +2134,4 @@
 	char *where = NULL;
 	int status = 0;
-	char *me = NULL;
 
 	struct yahoo_buddy *bud = NULL;
@@ -2148,5 +2141,5 @@
 		struct yahoo_pair *pair = l->data;
 		if (pair->key == 1)
-			me = pair->value;
+			; /* Me... don't care */
 		if (pair->key == 7)
 			who = pair->value;
@@ -2204,6 +2197,4 @@
 	char *who = NULL;
 	char *where = NULL;
-	int unk_66 = 0;
-	char *me = NULL;
 	struct yahoo_buddy *bud;
 
@@ -2214,5 +2205,5 @@
 		struct yahoo_pair *pair = l->data;
 		if (pair->key == 1)
-			me = pair->value;
+			; /* Me... don't care */
 		else if (pair->key == 7)
 			who = pair->value;
@@ -2220,5 +2211,5 @@
 			where = pair->value;
 		else if (pair->key == 66)
-			unk_66 = strtol(pair->value, NULL, 10);
+			; /* unk_66 */
 		else
 			DEBUG_MSG(("unknown key: %d = %s", pair->key,
@@ -2256,20 +2247,15 @@
 	struct yahoo_packet *pkt)
 {
-	char *who = NULL;
-	int status = 0;
-	char *me = NULL;
-	int un_ignore = 0;
-
 	YList *l;
 	for (l = pkt->hash; l; l = l->next) {
 		struct yahoo_pair *pair = l->data;
 		if (pair->key == 0)
-			who = pair->value;
+			; /* who */
 		if (pair->key == 1)
-			me = pair->value;
+			; /* Me... don't care */
 		if (pair->key == 13)	/* 1 == ignore, 2 == unignore */
-			un_ignore = strtol(pair->value, NULL, 10);
+			;
 		if (pair->key == 66)
-			status = strtol(pair->value, NULL, 10);
+			; /* status */
 	}
 
@@ -2293,5 +2279,4 @@
 	char *me = NULL;
 	char *room = NULL;
-	char *voice_room = NULL;
 
 	YList *l;
@@ -2303,5 +2288,5 @@
 			me = pair->value;
 		if (pair->key == 13)
-			voice_room = pair->value;
+			; /* voice room */
 		if (pair->key == 57)
 			room = pair->value;
@@ -2438,5 +2423,4 @@
 	struct yahoo_packet *pkt)
 {
-	char *me = NULL;
 	char *key = NULL;
 	char *who = NULL;
@@ -2447,5 +2431,5 @@
 		struct yahoo_pair *pair = l->data;
 		if (pair->key == 5)
-			me = pair->value;
+			; /* me */
 		if (pair->key == 61)
 			key = pair->value;
@@ -3369,5 +3353,4 @@
 	struct yahoo_webcam *wcm = y->wcm;
 	struct yahoo_input_data *yid;
-	struct yahoo_server_settings *yss;
 
 	if (!wcm || !wcm->server || !wcm->key)
@@ -3381,6 +3364,4 @@
 	yid->wcm = y->wcm;
 	y->wcm = NULL;
-
-	yss = y->yd->server_settings;
 
 	yid->wcd = y_new0(struct yahoo_webcam_data, 1);
@@ -4975,6 +4956,4 @@
 	YList *l;
 	struct send_file_data *sfd;
-	char *who = NULL;
-	char *filename = NULL;
 	char *id = NULL;
 	char *token = NULL;
@@ -4984,5 +4963,5 @@
 		switch (pair->key) {
 		case 4:
-			who = pair->value;
+			/* who */
 			break;
 		case 5:
@@ -4998,5 +4977,5 @@
 			break;
 		case 27:
-			filename = pair->value;
+			/* filename */
 			break;
 		}
@@ -5023,6 +5002,4 @@
 {
 	YList *l;
-	char *who = NULL;
-	char *filename = NULL;
 	char *id = NULL;
 	char *token = NULL;
@@ -5036,5 +5013,5 @@
 		case 1:
 		case 4:
-			who = pair->value;
+			/* who */
 			break;
 		case 5:
@@ -5053,5 +5030,5 @@
 			break;
 		case 27:
-			filename = pair->value;
+			/* filename */
 			break;
 		}