Index: debian/bitlbee.init
===================================================================
--- debian/bitlbee.init	(revision 59169956e1f7a5dd86e3c1aab41bc6a252f7b653)
+++ debian/bitlbee.init	(revision 25dfb16035f12ba15ad5fcfb6d428386ac4c38ce)
@@ -41,12 +41,4 @@
 	chown bitlbee: /var/run/bitlbee.pid
 	
-	# Clean up after the bug between 1.2-5 and 1.2.1-2 where BitlBee ran
-	# as root. (#494656 and #495877) Fixing this in the postinst script
-	# is not enough since the user will restart his BitlBee after up-
-	# grading the package, and the BitlBee running as root will then
-	# save its settings, re-setting ownership of the file to root.
-	# TODO: Remove this after a few revisions.
-	find /var/lib/bitlbee -uid 0 -name '*.xml' -exec chown bitlbee: {} \;
-
 	start-stop-daemon --start --quiet --pidfile $PIDFILE \
 		--exec $DAEMON -- -p $BITLBEE_PORT -P $PIDFILE $BITLBEE_OPTS
Index: debian/changelog
===================================================================
--- debian/changelog	(revision 59169956e1f7a5dd86e3c1aab41bc6a252f7b653)
+++ debian/changelog	(revision 25dfb16035f12ba15ad5fcfb6d428386ac4c38ce)
@@ -7,6 +7,13 @@
   * Fixed free port detection code in debian/config which was a bit limited
     and also buggy.
-
- -- Wilmer van der Gaast <wilmer@gaast.net>  Sun, 07 Jun 2009 20:40:00 +0100
+  * Removing code that edits bitlbee.conf from postinst (and chown code in
+    the init script), it's not really necessary anymore; bitlbee may only
+    still run as root if the admin doesn't read conffile diffs.
+    (Closes: #514572)
+  * No longer overwriting port number info in /etc/default/bitlbee with
+    what's in debconf. (Closes: #514148)
+  * Added notes about the above two changes to bitlbee.conf.
+
+ -- Wilmer van der Gaast <wilmer@gaast.net>  Sun, 07 Jun 2009 21:17:39 +0100
 
 bitlbee (1.2.3-1) unstable; urgency=critical
Index: debian/config
===================================================================
--- debian/config	(revision 59169956e1f7a5dd86e3c1aab41bc6a252f7b653)
+++ debian/config	(revision 25dfb16035f12ba15ad5fcfb6d428386ac4c38ce)
@@ -2,16 +2,21 @@
 
 . /usr/share/debconf/confmodule
+[ -f /etc/default/bitlbee ] && . /etc/default/bitlbee
 
 db_title BitlBee
 
-db_get bitlbee/serveport
-if [ "$RET" = "stillhavetoask" ]; then
-	listens=$(netstat -ltn | awk '{print $4}')
-	for port in 6667 6666 6668 6669; do
-		if [ $(expr "$listens " : ".*:$port\s") = "0" ]; then
-			break
-		fi
-	done
-	db_set bitlbee/serveport $port;
+if [ -n "$BITLBEE_PORT" ]; then
+	db_set bitlbee/serveport "$BITLBEE_PORT"
+else
+	db_get bitlbee/serveport
+	if [ "$RET" = "stillhavetoask" ]; then
+		listens=$(netstat -ltn | awk '{print $4}')
+		for port in 6667 6666 6668 6669; do
+			if [ $(expr "$listens " : ".*:$port\s") = "0" ]; then
+				break
+			fi
+		done
+		db_set bitlbee/serveport $port;
+	fi
 fi
 
Index: debian/patches/bitlbee.conf.diff
===================================================================
--- debian/patches/bitlbee.conf.diff	(revision 59169956e1f7a5dd86e3c1aab41bc6a252f7b653)
+++ debian/patches/bitlbee.conf.diff	(revision 25dfb16035f12ba15ad5fcfb6d428386ac4c38ce)
@@ -1,13 +1,22 @@
-=== modified file 'bitlbee.conf'
---- debian/bitlbee/etc/bitlbee/bitlbee.conf	2008-08-26 22:33:54 +0000
-+++ debian/bitlbee/etc/bitlbee/bitlbee.conf	2008-08-27 23:18:13 +0000
-@@ -23,7 +23,7 @@
+--- bitlbee.conf	2009-06-01 00:20:24.000000000 +0100
++++ /tmp/bitlbee.conf	2009-06-07 21:16:19.000000000 +0100
+@@ -23,13 +23,18 @@
  ## If BitlBee is started by root as a daemon, it can drop root privileges,
  ## and change to the specified user.
  ##
 -# User = bitlbee
++## DEBIAN NOTE: Without this, BitlBee will run as root!
++##
 +User = bitlbee
  
  ## DaemonPort/DaemonInterface:
  ##
-
+ ## For daemon mode, you can specify on what interface and port the daemon
+ ## should be listening for connections.
+ ##
++## DEBIAN NOTE: The init script passes the -p flag to use the port number
++## set using debconf, this overrides the DaemonPort setting here.
++##
+ # DaemonInterface = 0.0.0.0
+ # DaemonPort = 6667
+ 
Index: debian/postinst
===================================================================
--- debian/postinst	(revision 59169956e1f7a5dd86e3c1aab41bc6a252f7b653)
+++ debian/postinst	(revision 25dfb16035f12ba15ad5fcfb6d428386ac4c38ce)
@@ -33,5 +33,5 @@
 ## /etc/default/bitlbee: Auto-generated/updated script.
 ##
-## Don't edit this line, use dpkg-reconfigure bitlbee
+## If running in (fork)daemon mode, listen on this TCP port.
 BITLBEE_PORT="$PORT"
 
@@ -61,11 +61,4 @@
 	else
 		mv /usr/share/bitlbee/help.upgrading /usr/share/bitlbee/help.txt
-	fi
-fi
-
-if ! grep -qi '^User *= *' /etc/bitlbee/bitlbee.conf; then
-	echo 'Updating configuration file, enabling User-setting...'
-	if ! sed -i -e 's/# *User *= *.*/User = bitlbee/i' /etc/bitlbee/bitlbee.conf; then
-		echo 'Failed! BitlBee may run as root now, please check your configs.'
 	fi
 fi