Index: doc/CHANGES
===================================================================
--- doc/CHANGES	(revision 3ad80364e4d8aac620120b630df8a164d58dd114)
+++ doc/CHANGES	(revision 27b407fde1844a0e03f1a9d92d2a1c4a40435f9b)
@@ -4,11 +4,9 @@
 http://bugs.bitlbee.org/bitlbee/timeline?daysback=90&changeset=on
 
-Version 1.3dev:
-- For the first time since 2007, a dev snapshot. Like then, this is pretty
-  stable already (running on testing.bitlbee.org for weeks by now), but not
-  all planned features for the next major release are ready yet, and there
-  may be some rough edges in the interface and documentation.
-- Loads of new stuff, mostly ready for a new major release, but starting with
-  a dev snapshot. A few changes that were planned for a long time already:
+Version 
+- Important: This version drops backward compatibility with the file format
+  used for user settings in versions before 1.2. If you're upgrading from
+  very old BitlBee versions (like 1.0.x), you'll have to recreate your
+  BitlBee account - or use an 1.2.x BitlBee once to do the conversion.
 - Rewrote the IRC core, which brings:
   * Support for multiple (control) channels, so you can have one channel per
@@ -52,4 +50,11 @@
     for a list of supported protocols (works only in libpurple-enabled
     binaries).
+- Rewritten MSN module, implementing MSNP15 instead of the old MSNP8:
+  * MSNP8 support from MSN was getting pretty unreliable. There were issues
+    with remembering display names and adding contacts/auth requests (or
+    even contacts silently getting blocked!). This upgrade should fix all
+    of that.
+  * Support for sending offline messages.
+  * Support for setting and reading status messages.
 - Support for file transfers, in and out. /DCC SEND a file to a contact and
   it becomes a file transfer, and incoming file transfers become /DCC SENDs
@@ -58,6 +63,16 @@
 - Updated Yahoo! module to be in sync again with libyahoo2. This mostly
   fixes issues with authorization requests.
-
-Finished 6 Aug 2010
+- Show if a contact is mobile or not. See "help set mobile_is_away".
+- Easier handling of XMPP chatroom invitations.
+- The chatroom mode of the Twitter module is now enabled by default, since
+  this was by far the most popular. To disable it, see "help set mode".
+- Added some Twitter-specific commands that can only be used in the Twitter
+  window. Most important addition: Retweets. See "help set commands".
+- Removed some ancient account/nick migration scripts and added one for
+  easier switching from Pidgin and other libpurple-based clients to BitlBee.
+- Many bug fixes in both the core and IM modules, small feature enhancements
+  and other minor changes.
+
+Finished ...
 
 Version 1.2.8:
Index: doc/FAQ
===================================================================
--- doc/FAQ	(revision 3ad80364e4d8aac620120b630df8a164d58dd114)
+++ doc/FAQ	(revision 27b407fde1844a0e03f1a9d92d2a1c4a40435f9b)
@@ -62,15 +62,10 @@
    These days, we replaced the Yahoo! code with libyahoo2 (which is a
    separate Yahoo! module. It's derived from Gaim, but separately
-   maintained) and wrote our own MSN module. More modules are probably going
-   to be changed, so in the near future, the API might be the only thing
-   left from Gaim.
-
-Q: What's that Gaim doing in BitlBee error messages and my Jabber resource?
-A: Ah, well, as you probably know we use some of Gaim's IM-modules, and we
-   don't think it's worth our time to do a search-and-replace over the whole
-   source to get rid of every reference to Gaim. In fact, we don't want to,
-   since we don't want to pretend we wrote all that code.
+   maintained) and wrote our own MSN, Jabber and Twitter modules from
+   scratch. Most of the API has also been changed, so by now the only traces
+   of Gaim left are in the "nogaim" filename.
    
-   About Jabber: If you want a different resource string, you can set it
-   when logging in by appending it to your Jabber ID, like:
-   lintux@jabber.com/BitlBee
+   There is good news for Gaim (or now Pidgin, of course) fans though:
+   BitlBee can now be compiled to use libpurple for all IM interactions.
+   This makes BitlBee a bit more resource-hungry, but adds support for many
+   IM protocols/networks that couldn't be used from BitlBee so far.
Index: doc/README
===================================================================
--- doc/README	(revision 3ad80364e4d8aac620120b630df8a164d58dd114)
+++ doc/README	(revision 27b407fde1844a0e03f1a9d92d2a1c4a40435f9b)
@@ -67,14 +67,15 @@
 platform. Any recent version of GLib (2.4 or higher) will work.
 
-Off-the-Record encryption support will be included by default if the
-configure script finds libotr in one of the usual places. You can pass
---otr=1 or --otr=0 to force it on or off, respectively.
+Off-the-Record encryption support can be included if libotr is available on
+your machine. Pass --otr=1 to configure to build it into BitlBee, or
+--otr=plugin to build it as a separate loadable plugin (mostly meant for
+distro packages).
 
-These days, MSN Messenger clients have to connect to the MS Passport servers
-through HTTPS. BitlBee can use several SSL libraries for this: GnuTLS, NSS
-(which comes with Mozilla) and OpenSSL. OpenSSL is not GPL-compatible in some
-situations, so using GnuTLS or NSS is preferred. However, especially on *BSD,
-OpenSSL can be considered part of the operating system, which eliminates the
-GPL incompatibility.
+These days, many IM protocols use SSL/TLS connections (for authentication
+or for the whole session). BitlBee can use several SSL libraries for this:
+GnuTLS, NSS (which comes with Mozilla) and OpenSSL. OpenSSL is not GPL-
+compatible in some situations, so using GnuTLS is preferred. However,
+especially on *BSD, OpenSSL can be considered part of the operating system,
+which eliminates the GPL incompatibility.
 
 The incompatibility is also the reason why the SSL library detection code
Index: doc/user-guide/commands.xml
===================================================================
--- doc/user-guide/commands.xml	(revision 3ad80364e4d8aac620120b630df8a164d58dd114)
+++ doc/user-guide/commands.xml	(revision 27b407fde1844a0e03f1a9d92d2a1c4a40435f9b)
@@ -1667,4 +1667,8 @@
 				Only the <emphasis>group list</emphasis> command is supported at the moment, which shows a list of all groups defined so far.
 			</para>
+			
+			<para>
+				If you want to move contacts between groups, you can use the IRC <emphasis>/invite</emphasis> command. Also, if you use the <emphasis>add</emphasis> command in a control channel configured to show just one group, the new contact will automatically be added to that group.
+			</para>
 		</description>
 	</bitlbee-command>
Index: doc/user-guide/misc.xml
===================================================================
--- doc/user-guide/misc.xml	(revision 3ad80364e4d8aac620120b630df8a164d58dd114)
+++ doc/user-guide/misc.xml	(revision 27b407fde1844a0e03f1a9d92d2a1c4a40435f9b)
@@ -175,5 +175,39 @@
 
 <para>
-If you want to configure your own channels, you can use the <emphasis>channel set</emphasis>.
+If you want to configure your own channels, you can use the <emphasis>channel set</emphasis> command. See <emphasis>help channels3</emphasis> for more information.
+</para>
+
+</sect1>
+
+<sect1 id="channels3">
+<title>Configuring a control channel</title>
+
+<para>
+The most important setting for a control channel is <emphasis>fill_by</emphasis>. It
+tells BitlBee what information should be used to decide if someone should be shown
+in the channel or not. After setting this setting to, for example, <emphasis>account</emphasis>, you
+also have to set the <emphasis>account</emphasis> setting. Example:
+</para>
+
+<ircexample>
+	<ircline nick="wilmer">chan set &amp;wlm fill_by account</ircline>
+	<ircline nick="root">fill_by = `account'</ircline>
+	<ircline nick="wilmer">chan set &amp;wlm account msn</ircline>
+	<ircline nick="root">account = `msn'</ircline>
+</ircexample>
+
+<para>
+Also, each channel has a <emphasis>show_users</emphasis> setting which lets you
+choose, for example, if you want to see only online contacts in a channel, or
+also/just offline contacts. Example:
+</para>
+
+<ircexample>
+	<ircline nick="wilmer">chan set &amp;offline show_users offline</ircline>
+	<ircline nick="root">show_users = `offline'</ircline>
+</ircexample>
+
+<para>
+See the help information for all these settings for more information.
 </para>
 
@@ -234,6 +268,39 @@
 </sect1>
 
+<sect1 id="whatsnew010206">
+<title>New stuff in BitlBee 1.2.6</title>
+
+<para>
+Twitter support. See <emphasis>help account add twitter</emphasis>.
+</para>
+</sect1>
+
+<sect1 id="whatsnew010300">
+<title>New stuff in BitlBee 1.3dev</title>
+
+<para>
+Support for multiple configurable control channels, each with a subset of
+your contact list. See <emphasis>help channels</emphasis> for more
+information.
+</para>
+
+<para>
+File transfer support for some protocols (more if you use libpurple). Just
+/DCC SEND stuff. Incoming files also become DCC transfers.
+</para>
+
+<para>
+Only if you run your own BitlBee instance: You can build a BitlBee that uses
+libpurple for connecting to IM networks instead of its own code, adding
+support for some of the more obscure IM protocols and features.
+</para>
+
+<para>
+Many more things, briefly described in <emphasis>help news1.3</emphasis>.
+</para>
+</sect1>
+
 <sect1 id="news1.3">
-<title>New stuff in BitlBee 1.3dev</title>
+<title>New stuff in BitlBee 1.3dev (details)</title>
 
 <para>