Index: protocols/skype/t/add-no-bitlbee.mock
===================================================================
--- protocols/skype/t/add-no-bitlbee.mock	(revision ef64837002edb06f2e6048424749a52606d9e88e)
+++ 	(revision )
@@ -1,9 +1,0 @@
->> NOTICE AUTH
-<< NICK alice
-<< USER alice alice localhost :Alice
->> PRIVMSG &bitlbee
-<< PRIVMSG &bitlbee :account add skype alice foo
-<< PRIVMSG &bitlbee :account skype on
->> PRIVMSG &bitlbee :skype - New request: The user bob wants to add you
-<< PRIVMSG &bitlbee :no
->> PRIVMSG &bitlbee :skype - Rejected
Index: protocols/skype/t/add-no-skyped.mock
===================================================================
--- protocols/skype/t/add-no-skyped.mock	(revision ef64837002edb06f2e6048424749a52606d9e88e)
+++ 	(revision )
@@ -1,13 +1,0 @@
->> SEARCH GROUPS CUSTOM
-<< GROUPS 48, 49
->> SEARCH FRIENDS
-<< USERS echo123
->> SET USERSTATUS ONLINE
-<< USERSTATUS ONLINE
->> SET USERSTATUS ONLINE
-<< USERSTATUS ONLINE
->> GET USER echo123 ONLINESTATUS
-<< USER echo123 ONLINESTATUS ONLINE
-<< USER bob RECEIVEDAUTHREQUEST Please allow me to see when you are online
->> SET USER bob ISAUTHORIZED FALSE
-<< USER bob ISAUTHORIZED FALSE
Index: protocols/skype/t/add-yes-bitlbee.mock
===================================================================
--- protocols/skype/t/add-yes-bitlbee.mock	(revision ef64837002edb06f2e6048424749a52606d9e88e)
+++ 	(revision )
@@ -1,9 +1,0 @@
->> NOTICE AUTH
-<< NICK alice
-<< USER alice alice localhost :Alice
->> PRIVMSG &bitlbee
-<< PRIVMSG &bitlbee :account add skype alice foo
-<< PRIVMSG &bitlbee :account skype on
->> PRIVMSG &bitlbee :skype - New request: The user bob wants to add you
-<< PRIVMSG &bitlbee :yes
->> :bob!bob@skype.com JOIN :&bitlbee
Index: protocols/skype/t/add-yes-skyped.mock
===================================================================
--- protocols/skype/t/add-yes-skyped.mock	(revision ef64837002edb06f2e6048424749a52606d9e88e)
+++ 	(revision )
@@ -1,23 +1,0 @@
->> SEARCH GROUPS CUSTOM
-<< GROUPS 48, 49
->> SEARCH FRIENDS
-<< USERS echo123
->> SET USERSTATUS ONLINE
-<< USERSTATUS ONLINE
->> SET USERSTATUS ONLINE
-<< USERSTATUS ONLINE
->> GET USER echo123 ONLINESTATUS
-<< USER echo123 ONLINESTATUS ONLINE
-<< USER bob RECEIVEDAUTHREQUEST Please allow me to see when you are online
->> SET USER bob ISAUTHORIZED TRUE
-<< USER bob ISAUTHORIZED TRUE
-<< USER bob RECEIVEDAUTHREQUEST 
-<< USER bob ISAUTHORIZED TRUE
-<< USER bob ISBLOCKED FALSE
-<< USER bob BUDDYSTATUS 3
-<< USER bob ONLINESTATUS OFFLINE
-<< USER bob ONLINESTATUS ONLINE
-<< USER bob TIMEZONE 90000
-<< USER bob FULLNAME Miklos V
-<< USER bob LANGUAGE hu Hungarian
-<< USER bob COUNTRY hu Hungary
Index: protocols/skype/t/added-no-bitlbee.mock
===================================================================
--- protocols/skype/t/added-no-bitlbee.mock	(revision 33ed4558048f8dd5a29275658b3d1892b7b4dd74)
+++ protocols/skype/t/added-no-bitlbee.mock	(revision 33ed4558048f8dd5a29275658b3d1892b7b4dd74)
@@ -0,0 +1,9 @@
+>> NOTICE AUTH
+<< NICK alice
+<< USER alice alice localhost :Alice
+>> PRIVMSG &bitlbee
+<< PRIVMSG &bitlbee :account add skype alice foo
+<< PRIVMSG &bitlbee :account skype on
+>> PRIVMSG &bitlbee :skype - New request: The user bob wants to add you
+<< PRIVMSG &bitlbee :no
+>> PRIVMSG &bitlbee :skype - Rejected
Index: protocols/skype/t/added-no-skyped.mock
===================================================================
--- protocols/skype/t/added-no-skyped.mock	(revision 33ed4558048f8dd5a29275658b3d1892b7b4dd74)
+++ protocols/skype/t/added-no-skyped.mock	(revision 33ed4558048f8dd5a29275658b3d1892b7b4dd74)
@@ -0,0 +1,13 @@
+>> SEARCH GROUPS CUSTOM
+<< GROUPS 48, 49
+>> SEARCH FRIENDS
+<< USERS echo123
+>> SET USERSTATUS ONLINE
+<< USERSTATUS ONLINE
+>> SET USERSTATUS ONLINE
+<< USERSTATUS ONLINE
+>> GET USER echo123 ONLINESTATUS
+<< USER echo123 ONLINESTATUS ONLINE
+<< USER bob RECEIVEDAUTHREQUEST Please allow me to see when you are online
+>> SET USER bob ISAUTHORIZED FALSE
+<< USER bob ISAUTHORIZED FALSE
Index: protocols/skype/t/added-yes-bitlbee.mock
===================================================================
--- protocols/skype/t/added-yes-bitlbee.mock	(revision 33ed4558048f8dd5a29275658b3d1892b7b4dd74)
+++ protocols/skype/t/added-yes-bitlbee.mock	(revision 33ed4558048f8dd5a29275658b3d1892b7b4dd74)
@@ -0,0 +1,9 @@
+>> NOTICE AUTH
+<< NICK alice
+<< USER alice alice localhost :Alice
+>> PRIVMSG &bitlbee
+<< PRIVMSG &bitlbee :account add skype alice foo
+<< PRIVMSG &bitlbee :account skype on
+>> PRIVMSG &bitlbee :skype - New request: The user bob wants to add you
+<< PRIVMSG &bitlbee :yes
+>> :bob!bob@skype.com JOIN :&bitlbee
Index: protocols/skype/t/added-yes-skyped.mock
===================================================================
--- protocols/skype/t/added-yes-skyped.mock	(revision 33ed4558048f8dd5a29275658b3d1892b7b4dd74)
+++ protocols/skype/t/added-yes-skyped.mock	(revision 33ed4558048f8dd5a29275658b3d1892b7b4dd74)
@@ -0,0 +1,23 @@
+>> SEARCH GROUPS CUSTOM
+<< GROUPS 48, 49
+>> SEARCH FRIENDS
+<< USERS echo123
+>> SET USERSTATUS ONLINE
+<< USERSTATUS ONLINE
+>> SET USERSTATUS ONLINE
+<< USERSTATUS ONLINE
+>> GET USER echo123 ONLINESTATUS
+<< USER echo123 ONLINESTATUS ONLINE
+<< USER bob RECEIVEDAUTHREQUEST Please allow me to see when you are online
+>> SET USER bob ISAUTHORIZED TRUE
+<< USER bob ISAUTHORIZED TRUE
+<< USER bob RECEIVEDAUTHREQUEST 
+<< USER bob ISAUTHORIZED TRUE
+<< USER bob ISBLOCKED FALSE
+<< USER bob BUDDYSTATUS 3
+<< USER bob ONLINESTATUS OFFLINE
+<< USER bob ONLINESTATUS ONLINE
+<< USER bob TIMEZONE 90000
+<< USER bob FULLNAME Miklos V
+<< USER bob LANGUAGE hu Hungarian
+<< USER bob COUNTRY hu Hungary